from Widget import Widget
from Loader import Loader
import pygame

class Button(Widget):
	active_color = (196,196,196)
	passive_color = (32,32,32)

	def __init__(self,x,y,callback):
		Widget.__init__(self,x,y,self.surface.get_size()[0],self.surface.get_size()[1])
		self.callback = callback
		self.active = False
		self.enabled = True
		self.overlay = pygame.surface.Surface(self.surface.get_size())
		self.overlay.fill((0,0,0))
		self.overlay.set_alpha(196)
		self.label = None
	
	def enable(self,status=True):
		self.enabled = status
		
	def update(self):
		Widget.update(self)
	
	def mouseover(self,x,y):
		self.active = Widget.mouseover(self,x,y)
		return self.active
	
	def click(self,x,y):
		if(Widget.mouseover(self,x,y) and self.enabled):
			self.callback()
			return True
		return False
		
	def draw(self,surf):
		surf.blit(self.surface,(self.x,self.y))
		if self.active and self.enabled:
			pygame.draw.rect(surf,self.active_color,pygame.Rect(self.x-2,self.y-2,self.rect.w+3,self.rect.h+3),2)
		else:
			pygame.draw.rect(surf,self.passive_color,pygame.Rect(self.x-2,self.y-2,self.rect.w+3,self.rect.h+3),2)
		if not self.enabled:
			surf.blit(self.overlay,(self.x,self.y))
		elif self.active and self.label != None:
			surf.blit(self.label,self.label_pos)