import pygame
from Widget import Widget
from StaticText import StaticText
from Loader import Loader
import os

class Item(Widget):
	def __init__(self,x,y,w,item,icon,amount,bg=(0,0,0)):
		h = 48
		self.surface = pygame.surface.Surface((w,h))
		Widget.__init__(self,x,y,w,h)
		self.surface.fill( bg )
		
		# Elements
		icon = Loader().load_art(icon)[0]
		self.item_s = StaticText(icon.get_size()[0]+14,4,item,(255,255,255),16)
			
		self.surface.blit(icon,(8,6))
		self.item_s.draw(self.surface)
		pygame.draw.line(self.surface,(bg[0]+64,bg[1]+64,bg[2]+64),(0,h-1),(w,h-1),2)
	
	def draw(self,surf):
		surf.blit(self.surface,(self.x,self.y))
	
	def mouseover(self,x,y):
		return False

class CargoItem(Item):
	def __init__(self,x,y,w,item,icon,amount,bg=(0,0,0),capacity=None):
		Item.__init__(self,x,y,w,item,icon,amount,bg)
		amount_s = StaticText(self.item_s.x+32,self.item_s.y+self.item_s.size[1]+6,str(int(amount*100)/100.0) + " m^3",(128,128,128),16)
		if capacity != None:
			amount_s.x += (w-amount_s.x-amount_s.size[0])*(amount/capacity)
		amount_s.draw(self.surface)

class MarketItem(Item):
	def __init__(self,x,y,w,item,icon,price,bg=(0,0,0)):
		Item.__init__(self,x,y,w,item,icon,price,bg)
		price_s = StaticText(self.item_s.x+32,self.item_s.y+self.item_s.size[1]+6,str(int(price*100)/100.0),(216,216,216),16)
		euro = Loader().load_art("euro.png")[0]
		price_s.draw(self.surface)
		self.surface.blit(euro,(price_s.x+price_s.size[0]+4,price_s.y))
	