import pygame
from Loader import Loader
from State import State
from Overlay import Overlay
from StaticText import *
from CargoItem import CargoItem
from Line import Line
from TextButton import TextButton

class CargoOverlay(Overlay):
	def __init__(self):
		self.state = State()
		Overlay.__init__(self,"cargo")

	def render(self):
		Overlay.render(self)
		
		# Dividing line
		self.add(Line((self.size[0]/2,self.start_y+5),(self.size[0]/2,self.size[1]-5),self.textcolor,2))
		
		# Labels:
		cargo = self.state.player.getCargo()
		y = self.start_y
		x = 1
		bars = []
		bg = (0,0,0)
		for mineral,amount in cargo[0].items():
			if amount > 0.0:
				if bg[0] == 0:
					bg = (32,32,32)
				else:
					bg = (0,0,0)
				item = CargoItem(x,y,self.size[0]/2-1,mineral,self.state.resources[mineral.lower()]['icon'],amount,bg,cargo[2])
				self.add(item)
				y += item.size[1]
		diff = cargo[2]-cargo[1]
		if diff < 0.0:
			diff = 0.0
		remain = Paragraph(0,y+16,"Space remaining:\n"+str(int(diff*100)/100.0)+" m^3",(255,255,255),24)
		remain.align("center",self.size[0]/2)
		self.add(remain)
		
		dump_button = TextButton(8,0,"Dump Cargo",self.dump_callback)
		dump_button.y = self.size[1]-dump_button.size[1]-8
		if cargo[1] == 0:
			dump_button.enabled = False
		self.add(dump_button)
	
	def dump_callback(self):
		self.state.player.dumpCargo()
		self.render()