import pygame
from State import State

class DirectionIndicator:
	def __init__(self,target,color=(255,255,255)):
		self.state = State()
		self.size = 10
		self.surface = pygame.surface.Surface((self.size+1,self.size+1))
		self.surface.set_alpha(196)
		self.surface.set_colorkey( (0,0,0) )
		self.color = color
		pygame.draw.polygon(self.surface,self.color,[[0,self.size/2],[self.size/2,0],[self.size,self.size/2],[self.size/2,self.size]])
		self.center = (self.state.screen_size[0]/2,self.state.screen_size[1]/2)
		self.target = target
		self.pos = None
		
	def update(self):
		if self.target == None:
			self.pos = None
			return
		if self.target in self.state.onscreen:
			self.pos = None
		else:
			try:
				rel = self.state.world_to_screen(self.target.x,self.target.y)
				rel = (rel[0]-self.center[0],rel[1]-self.center[1])
				slope = rel[1]/rel[0]
				if rel[0] < 0: # player is right of ceres
					y = self.center[1]-slope*self.center[0]
					x = -self.size/2
					if y < 0:
						y = -self.size/2
						x = self.center[0] + -self.center[1]/slope
					elif y > self.state.screen_size[1]:
						y = self.state.screen_size[1]-self.size/2
						x = self.center[0] + self.center[1]/slope
				else:
					x = self.state.screen_size[0]-self.size/2-1
					y = self.center[1]+slope*self.center[0]
					if y < 0:
						y = -self.size/2
						x = self.center[0] + -self.center[1]/slope
					elif y > self.state.screen_size[1]:
						y = self.state.screen_size[1]-self.size/2
						x = self.center[0] + self.center[1]/slope
				self.pos = (x,y)
			except ZeroDivisionError:
				pass
	def draw(self,surf):
		if self.pos:
			surf.blit(self.surface,self.pos)