import pygame
import os
from Overlay import Overlay
from CargoItem import MarketItem
import ConfigParser
from State import State

class MarketOverlay(Overlay):
	def __init__(self):
		self.state = State()
		Overlay.__init__(self,"Market")
	
	def mineral_callback(self):
		pass
	
	def render(self):
		Overlay.render(self)
		market = self.state.market
		y = self.start_y+8
		prices = []
		w = 0
		bg = (0,0,0)
		for mineral,price in market.prices.items():
			button = MarketItem(1,y,self.size[0]-2,mineral,self.state.resources[mineral.lower()]['icon'],price,bg)
			if bg[0] == 0:
				bg = (32,32,32)
			else:
				bg = (0,0,0)
			self.add(button)
			y += button.size[1]