import pygame
from Loader import Loader
from Widget import Widget

class PercentBar(Widget):
	def __init__(self,x,y,value=1):
		w = 128
		h = 20
		Widget.__init__(self,x,y,w,h)
		self.font = Loader().load_font("slkscr",8)
		self.text_color = [0,0,0]
		self.border_color = (64,64,64)
		self.surface = pygame.surface.Surface((w,h))
		self.surface.set_colorkey( (0,0,0) )
		self.value = value
		self.redraw()
	
	def set_alpha(self,alpha):
		self.surface.set_alpha(alpha)
	
	def change(self,value):
		self.value = value
		self.redraw()
	
	def redraw(self):
		self.surface.fill( (0,0,0) )
		c = 192*self.value
		fill_color = (c,c,c)
		ic = 0
		if self.value < 0.6:
			ic = 255
		label_color = (ic,ic,ic)
		pygame.draw.rect(self.surface,self.border_color,pygame.Rect(0,0,self.size[0],self.size[1]),1)
		for i in range(1,4):
			pygame.draw.line(self.surface,self.border_color,(self.size[0]/4*i,0),(self.size[0]/4*i,2))
			pygame.draw.line(self.surface,self.border_color,(self.size[0]/4*i,self.size[1]),(self.size[0]/4*i,self.size[1]-2))
		pygame.draw.rect(self.surface,fill_color,pygame.Rect(4,4,(self.size[0]-8)*self.value,self.size[1]-8))
		label = self.font.render(str(int(self.value*100))+"%",False,label_color)
		self.surface.blit(label,(self.size[0]/2-label.get_size()[0]/2,self.size[1]/2-label.get_size()[1]/2))
	
	def draw(self,surf):
		surf.blit(self.surface,(self.x,self.y))
		