import pygame
from State import State

class Widget:
	def __init__(self,x,y,w,h):
		self.state = State()
		self.coords = (x,y)
		self.size = (w,h)
		self.rect = pygame.Rect(x,y,w,h)
		self.x = self.coords[0]
		self.y = self.coords[1]
		self.alpha = 1.0
		self._item = None
		self.visible = True
	
	def set_x(self,x):
		self.x = x
	
	def get_x(self):
		return x
	
	def set_y(self,y):
		self.y = y
	
	def get_y(self):
		return y

	def set_width(self,w):
		self.rect.w = w
		self.size = (w,self.size[1])
	
	def get_width(self):
		return self.size[0]

	def set_height(self,h):
		self.rect.h = h
		self.size = (self.size[0],h)
	
	def get_height(self):
		return self.size[1]
	
	x = property(get_x,set_x)
	y = property(get_y,set_y)
	width = property(get_width,set_width)
	height = property(get_height,set_height)
	
	def set_item(self,x):
		self._item = x
	
	def get_item(self):
		return self._item
	
	item = property(set_item,get_item)
	
	def set_alpha(self,alpha):
		self.alpha = alpha
	
	def getRect(self):
		return pygame.Rect(self.x,self.y,self.size[0],self.size[1])
	
	def update(self):
		pass
	
	def draw(self,surf):
		pass
	
	def mouseover(self,x,y):
		return self.getRect().collidepoint(x,y)
	
	def click(self,x,y):
		return self.mouseover(x,y)