import pygame
from State import State

class Label:
	
	alpha = True
	# Create a new label with the provided string, SDLFont object, rgb tuple, and coordinate pair.
	def __init__(self,string,font,color,coords,width=None,maxHeight=None,bgcolor=(255,255,255)):
		state = State()
		if not width:
			width = state.screen_size[0]
		self.font = font
		mwidth = font.size("n")[0]
		
		surfaces = []
		self.strings = []
		while len(string) > 0:
			if mwidth * len(string) > width or string.find("\n") > -1:
				chars = int(width/mwidth)
				split_at = string.rfind(" ",0,chars)
				if split_at == -1:
					split_at = chars
				newline = string.rfind("\n",0,split_at)
				if newline > -1:
					split_at = newline
				str1 = string[:split_at].replace("\n","")
				str2 = string[split_at+1:]
				surface = font.render(str1,Label.alpha,color)
				surfaces.append(surface)
				string = str2
				self.strings.append(str1)
			else:
				surface = font.render(string,Label.alpha,color)
				surfaces.append(surface)
				self.strings.append(string)
				string = ""
		ww = 0
		for s in surfaces:
			tw = s.get_size()[0]
			if tw > ww:
				ww = tw
		if ww > width:
			ww = width
		ww += 12
		hh = surfaces[0].get_size()[1]*len(surfaces)
		if maxHeight and hh > maxHeight:
			hh = maxHeight
		self.surface = pygame.surface.Surface( (ww,hh) )
	#	self.surface.fill(bgcolor)
		self.surface.set_colorkey((0,0,0))
		y = 0
		for surf in surfaces:
			self.surface.blit(surf,(0,y))
			y += surf.get_size()[1]
		
		size = self.surface.get_size()
		self.width = size[0]
		self.height = size[1]
		self.coords = coords
		self.alpha = 128
		self.surface.set_alpha(self.alpha)
		self.goal_alpha = 255
		self.shadow = False
		self.string = string
		self.visible = True

	# Toggle whether a 50% alpha dropshadow is drawn under this label
	def set_shadow(self,bool):
		self.shadow = bool
	
	def set_alpha(self,a,hold=True):
		self.alpha = a
		self.surface.set_alpha(a)
		if(hold):
			self.goal_alpha = a
	
	def set_y(self,y):
		self.coords = (self.coords[0],y)
	
	def set_x(self,x):
		self.coords = (x,self.coords[1])
		
	def draw(self,surf):
		if self.is_visible():
			if self.shadow:
				self.surface.set_alpha(self.alpha/2)
				surf.blit(self.surface,(self.coords[0]+2,self.coords[1]+2))
				self.surface.set_alpha(self.alpha)
			surf.blit(self.surface,self.coords)
		
	def update(self):
		a = self.alpha
		if self.goal_alpha < self.alpha:
			self.alpha -= 15
			if self.alpha < self.goal_alpha:
				self.alpha = self.goal_alpha
		elif self.goal_alpha > self.alpha:
			self.alpha += 15
			if self.alpha > self.goal_alpha:
				self.alpha = self.goal_alpha
		if a != self.alpha:
			self.surface.set_alpha(self.alpha)
			
	def fade(self,alpha = 0):
		self.goal_alpha = alpha
	
	def show(self,bool=True):
		self.visible = bool
		
	def is_visible(self):
		return (self.alpha > 0) and self.visible