from State import State
import pygame
from Asteroid import AsteroidFactory

class PeriodicActions:
	def __init__(self,delay):
		self.tick = pygame.time.get_ticks()
		self.tock = pygame.time.get_ticks()
		self.delay = delay
		self.state = State()
		self.actions = []
	
	def add(self,method,interval):
		self.actions.append( [method,interval,self.tick + interval] )
	
	def elapsed(self):
		return float(pygame.time.get_ticks()-self.tock)/1000
	
	def remove(self,method):
		self.actions = filter(lambda action: action[0] == method,self.actions)
	
	def update(self):
		tock = pygame.time.get_ticks()
		self.tock = tock
		for action in self.actions:
			if tock >= action[2]:
				action[2] = tock + action[1]
				action[0]()
			
		# Hardcoded old-style action. TODO: update to use self.actions
		if tock > self.tick:
			self.tick = tock + self.delay
			
			# Update onscreen list
			screen_rect = self.state.screen_rect()
			self.state.onscreen = []
			for obj in self.state.space:
				if hasattr(obj,"children"): # Object is a Manager
					for child in obj.children():
						if screen_rect.colliderect(child.rect()):
							self.state.onscreen.append(child)
					# If this is an AsteroidManager, filter asteroids
					if isinstance(obj,AsteroidFactory):
						obj.filter_distant()
				else: # Object is an entity
					if screen_rect.colliderect(obj.rect()):
						self.state.onscreen.append(obj)
			
			# Update starfield
			self.state.starfield.flicker()