import os
import httplib
import urllib

class ScoreServer:
	def __init__(self,url_file=os.path.join("res","data","scores.url")):
		fin = open(url_file,"r")
		self.server = fin.readline().strip()
		self.path = fin.readline().strip()
		self.game_id = fin.readline().strip()
		self.url_file = url_file
	
	def submit(self,name,score,note):
		params = urllib.urlencode( {"game_id":self.game_id,"player":name,"score":score,"note":note} )
		headers = {"Content-type": "application/x-www-form-urlencoded","Accept":"text/plain"}
		http = httplib.HTTPConnection(self.server)
		http.request("POST",self.path+"submit_deeper.php",params,headers)
		resp = http.getresponse()
		if resp.status != 200 or resp.reason != "OK":
			return False
		
		# Contains response -- maybe send 'ranked nth out of m' ?
		data = resp.read()
		http.close()
		if data == "SUBMIT OK":
			return True
		else:
			lines = data.split("\n")
			if lines[0] == "REDIRECT":
				server = lines[1]
				path = lines[2]
				id = lines[3]
				fout = open(self.url_file,"w")
				fout.write(server)
				fout.write(path)
				fout.write(id)
				fout.close
				self.server = server
				self.path = path
				self.game_id = id
				return self.submit(name,score)
			else:
				return False
		return False
	
	def fetch_scores(self,limit=10):
		http = httplib.HTTPConnection(self.server)
		params = urllib.urlencode( {"game_id":self.game_id} )
		headers = {"Content-type": "application/x-www-form-urlencoded","Accept":"text/plain"}
		http.request("GET",self.path+"fetch_deeper.php",params,headers)
		resp = http.getresponse()
		if resp.status != 200 or resp.reason != "OK":
			return False
		html = resp.read()
		http.close()
		
		scores = []
		lines = html.split("\n")
		for line in lines:
			pair = line.rsplit(":",3)
			if len(pair) == 3:
				pair = [pair[0],pair[1],pair[2].split("_",2)[1]]
				scores.append(pair)
		return scores

# Unit test
# TODO: remove