import os
import pygame

def import_libs(dir):
		library_list = {} 
	
		for f in os.listdir(os.path.abspath(dir)):
			module_name, ext = os.path.splitext(f) # Handles no-extension files, etc.
			if ext == '.py': # Important, ignore .pyc/other files.
				print 'imported module: %s' % (module_name)
				module = __import__(module_name)
				library_list[module_name] = module
		return library_list

class State:
	__shared_state = {}
	
	def __init__(self):
		self.__dict__ = self.__shared_state
		
	def init_state(self):
		self.paused = False
		self.debug = False
		self.screen_size = (800,600)
		self.camera = [0,0]

	def pause(self,value=True):
		self.paused = value
	
	def offset(self,x,y):
		return (self.screen_size[0]/2 + x - self.camera[0],self.screen_size[1]/2 + y - self.camera[1])
	
	def screen_to_world(self,x,y):
		return (self.camera[0]-self.screen_size[0]/2+x,self.camera[1]-self.screen_size[1]/2+y)
	
	def world_to_screen(self,x,y):
		return self.offset(x,y)
	
	def screen_rect(self):
		top_left = self.screen_to_world(0,0)
		return pygame.Rect(0,0,self.screen_size[0],self.screen_size[1])
#		return pygame.Rect(self.camera[0]-self.screen_size[0]/2,self.camera[1] - self.screen_size[1]/2,self.screen_size[0],self.screen_size[1])