import pygame
from Loader import Loader
from State import State
from Widget import Widget
from Tile import *
from Particle import *

def tile_move(_coords,dir):
	coords = [_coords[0],_coords[1]]
	if dir == 0:
		coords[1]-=2
	elif dir == 1:
		coords[1] -= 1
		if coords[1] % 2 == 0:
			coords[0] += 1
	elif dir == 2:
		coords[1] += 1
		if coords[1] %2 == 0:
			coords[0] += 1
	elif dir == 3:
		coords[1] += 2
	elif dir == 4:
		coords[1] += 1
		if coords[1] %2 == 1:
			coords[0] -= 1
	elif dir == 5:
		coords[1] -= 1
		if coords[1] % 2 == 1:
			coords[0] -= 1
	return coords

class Entity(Widget):
	def __init__(self,character,color,map,coords):
		self.surface = Loader().load_font("VeraMono",16).render(character,True,color)
		Widget.__init__(self,0,0,self.surface.get_size()[0],self.surface.get_size()[1])
		self.map = map
		#self.particle = Exhaust((self.x,self.y),50,(255,192,0),1.1)
		#self.particle.on = True
		self.coords = [coords[0],coords[1]]
		self.update_coords()
	
	def move(self,dir):
		old_coords = [self.coords[0],self.coords[1]]
		self.coords = tile_move(self.coords,dir)
		tile = Tile(self.map.tile(self.coords[0],self.coords[1]))
		if not tile.walkable:
			self.coords = old_coords
			return False
		self.update_coords()
		return True

	def update(self):
		#self.particle.update()
		return True
	
	def reveal(self,change_to=0):
		self.map.map[self.coords[1]][self.coords[0]][1] = change_to
		# reveal in a circle around the player
		for dir in [0,1,2,3,4,5]:
			pos = tile_move(self.coords,dir)
			if pos[1] >= 0 and pos[1] < len(self.map.map) and pos[0] >= 0 and pos[0] < len(self.map.map[pos[0]]):
				self.map.map[pos[1]][pos[0]][1] = change_to
		pos = tile_move(self.coords,0)
		for dir in [0,2,2,3,3,4,4,5,5,0,0,1]:
			pos = tile_move(pos,dir)
			if pos[1] >= 0 and pos[1] < len(self.map.map) and pos[0] >= 0 and pos[0] < len(self.map.map[pos[0]]):
				self.map.map[pos[1]][pos[0]][1] = change_to
		self.map.render_fog(self.coords)
		
	def update_coords(self):
		pos = self.map.point_to_coords(self.coords[0],self.coords[1])
		self.x = pos[0]
		self.y = pos[1]
		#self.particle.coords = pos
		
	def draw(self,surf):
		if self.map.map[self.coords[1]][self.coords[0]][1] > 0 or True:
			surf.blit(self.surface,self.state.offset(self.x-self.size[0]/2,self.y-self.size[1]/2))
		#self.particle.draw(surf)
		#pygame.draw.circle(surf,(255,0,0),self.state.offset(self.x,self.y),3)