import pygame
from pygame.locals import *
from AbstractScreen import AbstractScreen
from SubmitScreen import SubmitScreen

from StaticText import StaticText

class DeathScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		text = StaticText(0,self.state.screen_size[1]/3,"Darkness closes around you!",(192,192,192),48)
		text.align("center")
		self.add(text)
		help = StaticText(0,text.y+text.size[1],"(press any key to return to the menu)",(192,192,192),11)
		help.align("center")
		self.add(help)
	
	def on_focus(self):
		self.state.escape = False
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		AbstractScreen.draw(self,screen)
	
	def handle_event(self,event):
		if event.type == KEYDOWN:
			self.state.score = self.state.gold + self.state.max_level*20
			self.state.switch_to_screen(SubmitScreen)
		return True
	
	# Return value:
	#	True -- successful update
	#	False -- Error in update OR done, and switch to previous screen
	def update(self):
		return AbstractScreen.update(self)