import pygame
from pygame.locals import *
from AbstractScreen import AbstractScreen
from SubmitScreen import SubmitScreen

from StaticText import StaticText

class EscapeScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		text = StaticText(0,self.state.screen_size[1]/3,"You escape the cave!",(16,16,16),48)
		text.align("center")
		self.add(text)
		help = StaticText(0,text.y+text.size[1],"(press any key to continue)",(32,32,32),11)
		help.align("center")
		self.add(help)
	
	def on_focus(self):
		self.state.escape = True
	
	def draw(self,screen):
		screen.fill( (255,255,255) )
		AbstractScreen.draw(self,screen)
	
	def handle_event(self,event):
		if event.type == KEYDOWN:
			self.state.score = self.state.gold * 1.5 + self.state.max_level*20
			self.state.switch_to_screen(SubmitScreen)
		return True
	
	# Return value:
	#	True -- successful update
	#	False -- Error in update OR done, and switch to previous screen
	def update(self):
		return AbstractScreen.update(self)