import pygame
from pygame.locals import *
from AbstractScreen import AbstractScreen
import TitleScreen

from StaticText import *

class HelpScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		
		text = Paragraph(5,10,"Seeking wealth and fame, you have entered\nthe cavern of fabled riches. Gather what\nyou can before your torch expires and return\nto the surface. Play it safe, or give in to\nyour desire to explore just a little...\n\n...Deeper",(255,255,255),24)
		text.align("center")
		self.add(text)
		
		you = StaticText(5,text.y+text.height+30,"@",(128,0,0),32)
		you_str = StaticText(you.x+you.width+10,you.y," - this is you",(255,255,255),32)
		you_str2 = StaticText(you_str.x+12,you_str.y+you_str.height,"(use q,w,e,a,s,d to move (hex directions))",(255,255,255),16)
		gold = StaticText(5,you_str2.y+you_str2.height+10,"$",(0,128,0),32)
		gold_str = StaticText(gold.x+gold.width+10,gold.y," - this is a pile of riches",(255,255,255),32)
		gold_str2 = StaticText(gold_str.x+12,gold_str.y+gold_str.height,"(walk over it to pick it up)",(255,255,255),16)
		wood = StaticText(5,gold_str2.y+gold_str2.height,"#",(128,96,0),32)
		wood_str = StaticText(wood.x+wood.width+10,wood.y," - this is fuel for your torch",(255,255,255),32)
		wood_str2 = StaticText(wood_str.x+12,wood_str.y+wood_str.height,"(walk over it to pick it up)",(255,255,255),16)
		stair = StaticText(5,wood_str2.y+wood_str2.height,">",(128,96,0),32)
		stair_str = StaticText(stair.x+stair.width+10,stair.y," - this is a stair down",(255,255,255),32)
		stair_str2 = StaticText(stair_str.x+12,stair_str.y+stair_str.height,"(press '>' to descend)",(255,255,255),16)
		stair2 = StaticText(5,stair_str2.y+stair_str2.height,"<",(128,96,0),32)
		stair2_str = StaticText(stair2.x+stair2.width+10,stair2.y," - this is a stair up",(255,255,255),32)
		stair2_str2 = StaticText(stair2_str.x+12,stair2_str.y+stair2_str.height,"(press '<' to ascend)",(255,255,255),16)
		scroll = StaticText(5,stair2_str2.y+stair2_str2.height*2+20,"Use the arrow keys to scroll",(255,255,255),32)
		scroll_str2 = StaticText(scroll.x+12,scroll.y+scroll.height,"(or grab & drag with the mouse)",(255,255,255),16)
		escape = StaticText(5,scroll_str2.y+scroll_str2.height*2+20,"Press escape to return to the menu",(255,255,255),32)
		
		for lbl in [you,you_str,you_str2,gold,gold_str,gold_str2,wood,wood_str,wood_str2,scroll,scroll_str2,escape,stair,stair_str,stair_str2,stair2,stair2_str,stair2_str2]:
			self.add(lbl)
		
	def on_focus(self):
		self.state.escape = True
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		AbstractScreen.draw(self,screen)
	
	def handle_event(self,event):
		if event.type == KEYDOWN:
			self.state.switch_to_screen(TitleScreen.TitleScreen)
		return True
	
	# Return value:
	#	True -- successful update
	#	False -- Error in update OR done, and switch to previous screen
	def update(self):
		return AbstractScreen.update(self)