from AbstractScreen import AbstractScreen
import os
import pygame
from Loader import Loader
from State import State
from Label import Label
from TitleScreen import TitleScreen

class PresentsScreen(AbstractScreen):
	def __init__(self,ttl):
		AbstractScreen.__init__(self)
		self.loader = Loader()
		self.state = State()
		large_font = self.loader.load_font("slkscr",128)
		med_font = self.loader.load_font("slkscr",48)
		small_font = self.loader.load_font("slkscr",16)
		x = self.state.screen_size[0]/2
		y = self.state.screen_size[1]/2
		self.labels = [ Label("Ludum Dare",med_font,(255,255,255),[x-280,y-60]),
						Label("16",large_font,(255,255,255),[x+70,y-50]),
						Label("presents",small_font,(255,96,96),[x,y+70])
		 			  ]
		for label in self.labels:
			label.alpha = 0
			label.goal_alpha = 255
		self.labels[1].coords = (self.labels[0].coords[0]+self.labels[0].width-12,self.labels[0].coords[1]-self.labels[1].height+self.labels[0].height+19)
		self.labels[2].coords = (self.labels[1].coords[0]-30,self.labels[0].coords[1]+self.labels[0].height-5)
		# Set up fade timer
		self.ttl = ttl
		self.loaded = False
	
	def on_focus(self):
		self.start = pygame.time.get_ticks()
		self.fade_out = self.start + self.ttl*1000
		self.alive = True
		
	def update(self):
		AbstractScreen.update(self)
		time = pygame.time.get_ticks()
		if time >= self.fade_out and self.alive:
			self.alive = False
			for label in self.labels:
				label.goal_alpha = 0
		elif time >= self.fade_out and self.labels[0].alpha == 0:
			self.state.switch_to_screen(TitleScreen)
		for label in self.labels:
			label.update()
		if self.labels[0].alpha == self.labels[0].goal_alpha and not self.loaded:
			self.loaded = True
			# Do preloading of audio
			self.sound = self.state.sound
			self.sound.load_music("Rock Rat")
			self.sound.load_music("Paranoia")
		return True
	
	def handle_event(self,event):
		if event.type == pygame.locals.KEYDOWN or event.type == pygame.locals.MOUSEBUTTONDOWN:
			self.fade_out = self.start
		return True
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		for label in self.labels:
			label.draw(screen)
		return True