from AbstractScreen import AbstractScreen
import sys
from pygame.locals import *
import os
import pygame
from Loader import Loader
from State import State
from Label import Label
from StaticText import StaticText
from ScoreServer import ScoreServer
import TitleScreen

class ScoresScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		self.loader = Loader()
		self.state = State()
		x = self.state.screen_size[0]/2
		y = self.state.screen_size[1]/6
		stitle = ["Top Scores"]
		self.title = []
		font = 60
		for title in stitle:
			lbl = StaticText(0,y,title,(255,255,255),60)
			lbl.align("center")
			lbl.shadow()
			self.title.append( lbl )
			y += lbl.height
			font = 30
		
		self.scores = []
		self.error = None
		
		help = StaticText(5,0,"Press Escape to return to menu",(200,200,200),16)
		help.y = self.state.screen_size[1]-help.height-5
		self.add(help)
		
		# Set up fade timer
		self.ttl = 255
		self.sound = self.state.sound
		self.state.score_server = ScoreServer()
	
	def on_focus(self):
		self.alive = True
		try:
			scores = self.state.score_server.fetch_scores()
			y = self.title[0].coords[1] + self.title[0].height
			self.scores = []
			index = 0
			for score in scores:
				print score
				c = (54,57,52)
				if index % 2 == 1:
					c = (104,107,102)
				if index > 10 and self.state.screen_size[1] == 600:
					break
				index += 1
				lbl = StaticText(0,y,"(" + str(score[1]) + ") " + score[0] + " " + score[2],(255,255,255),16)
				lbl.align("center")
				y += lbl.height + 5
				lbl.shadow()
				self.scores.append(lbl)
		except:
				self.error = StaticText(0,self.title[len(self.title)-1].y+self.title[len(self.title)-1].height+10,"Connection Failed",(255,57,52),30)
				self.error.align("center")
				self.error.shadow()
		self.error = None
		
	def update(self):
		AbstractScreen.update(self)
		return True
	
	def handle_event(self,event):
		if event.key == K_ESCAPE:
			self.state.switch_to_screen(TitleScreen.TitleScreen)
		return True
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		AbstractScreen.draw(self,screen)
		for label in self.title:
			label.draw(screen)
		for lbl in self.scores:
			lbl.draw(screen)
		if self.error:
			self.error.draw(screen)
		return True
