from AbstractScreen import AbstractScreen
import sys
from pygame.locals import *
import os
import pygame
from Loader import Loader
from State import State
from Label import Label
from StaticText import StaticText
from ScoreServer import ScoreServer
from ScoresScreen import ScoresScreen
import TitleScreen

class SubmitScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		self.loader = Loader()
		self.state = State()
		x = self.state.screen_size[0]/2
		y = self.state.screen_size[1]/6
		stitle = ["Your score: ","Type your name, then press 'Enter'"]
		self.title = []
		font = 60
		for title in stitle:
			lbl = StaticText(0,y,title,(255,255,255),font)
			lbl.align("center")
			lbl.shadow()
			self.title.append( lbl )
			y += lbl.height + 10
			font = 30
		
		self.name = ""
		self.name_lbl = StaticText(0,y," ",(255,255,255),72)
		self.name_lbl.align("center")
		self.name_lbl.shadow()
		
		help = StaticText(5,0,"Press Escape to skip",(200,200,200),16)
		help.y = self.state.screen_size[1]-help.height-5
		self.add(help)
		
		self.result = None
		

		# Set up fade timer
		self.ttl = 255
		self.sound = self.state.sound
		self.state.score_server = ScoreServer()
	
	def on_focus(self):
		self.title[0].set_text("Your score: "+str(int(self.state.score)))
		self.title[0].x = 0
		self.title[0].align("center")
		self.alive = True
#		self.sound.start_music(self.sound.get_track_number("Scene1"))
		self.result = None
		self.name = ""
		self.name_lbl.set_text(" ")
		
	def update(self):
		AbstractScreen.update(self)
		return True
	
	def handle_event(self,event):
		if event.type == pygame.locals.KEYDOWN:
			if event.key == K_RETURN and self.name != "":
				try:
					note = str(self.state.score)+"_died on level "+str(self.state.level) +" (max "+str(self.state.max_level)+")"
					if self.state.escape == True:
						note = str(self.state.score)+"_escaped (max "+str(self.state.max_level)+")"
					res = self.state.score_server.submit(self.name,self.state.score,note)
					if not res:
						raise "fail"
					self.result = StaticText(0,self.name_lbl.y+self.name_lbl.height,"Success!",(200,200,200),30)
					self.state.switch_to_screen(ScoresScreen)
				except:
					self.result = StaticText(0,self.name_lbl.y+self.name_lbl.height,"Connection Failed!",(200,20,20),30)
				self.result.align("center")
				self.result.shadow()
			elif event.key >= ord('a') and event.key <= ord('z') and len(self.name) < 10:
				self.name += event.unicode
				self.name_lbl.set_text(self.name)
				self.name_lbl.x = 0
				self.name_lbl.align("center")
			elif (event.key == K_DELETE or event.key == K_BACKSPACE) and len(self.name) > 0:
				self.name = self.name[:len(self.name)-1]
				self.name_lbl.set_text(self.name)
				self.name_lbl.x = 0
				self.name_lbl.align("center")
			elif event.key == K_ESCAPE:
				self.state.switch_to_screen(TitleScreen.TitleScreen)
		return True
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		AbstractScreen.draw(self,screen)
		for label in self.title:
			label.draw(screen)
		self.name_lbl.draw(screen)
		if self.result:
			self.result.draw(screen)
		return True
